/* Example.c
 * Michael McTernan, mm7323@bris.ac.uk
 * 1/4/00
 */

#include <stdlib.h>
#include <stdio.h>
#include "Set.h"

typedef struct {
  int Key;
  char Data[10];
} data_t;

/* Prototype */
static int Compare();


int main() {
  set_t  TheSet;
  data_t Data[80],*DataP;
  int    t;

  /* Create a set with 100 elements */
  /* Remember to have extra capacity so the hash
   *  is efficient (Otherwise performance goes
   *  towards O(n/m)
   */
  TheSet=SET_New(100,sizeof(int));

  /* Create the data and add it to a set 
   *   Note: This key creation scheme has the
   *          usually undesirable propertly of
   *          not creating unique keys
   */
  for(t=0;t<80;t++) {
    Data[t].Key=((float)rand()/(float)RAND_MAX)*80;
    strcpy(Data[t].Data,"Mike"); /* Put some real world data here! */

    SET_Add(TheSet,&Data[t].Key,&Data[t]);
  }
  
  /* Print the size */
  printf("Set created with %d elements.\n",SET_Size(TheSet));

  /* Retrieve the data using the keys */
  for(t=0;t<80;t++) {
    DataP=SET_Get(TheSet,&t);
    /* Do somthing useful with DataP here */
  }

  /* Or iterate the data */
  while((DataP=SET_Iterate(TheSet))!=NULL) {
    /* Do somthing useful with DataP here */
    printf("%d\t",DataP->Key);
  }

  /* Sort the set */  
  SET_Sort(TheSet,Compare);
  
  printf("\nSorted\n");

  /* Iterate the data again in sorted form */
  while((DataP=SET_Iterate(TheSet))!=NULL) {
    /* Do somthing useful with DataP here */
    printf("%d\t",DataP->Key);
  }

  printf("\n");

  /* Destroy the set */
  SET_Destroy(TheSet);

  return 0;

}

/*Compare*/
/* Comparison function for sorting the data 
 */
static int Compare(data_t *a,data_t *b) {
  if(a->Key<b->Key)
    return -1;
  if(a->Key>b->Key)
    return  1;

  return 0;
}
